
package engine;

import memory.*;

/**
Klasse zur Erzeugung eines Objekts der untergeordneten Maschine aus der Creator-Methode.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _creator extends Command {

 /**
 Creator
 */
 public _creator() {
  name = "creator";
 }

 /**
 Laufzeitverhalten des Commands.
 Bereitstelen eines Creators mit der angegeben Argumentliste.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
 String  with = (String)List.pop( machine.DS); // TOS --> {arg arg ...}
 String  argl = with.substring( 1, with.lastIndexOf( "}")).trim();
 Class   ocl  = (Class)List.pop( machine.DS);  // TOS --> Object-Class
 Class[] args = null;

  args = machine.argClasses( argl);
  try   {
         List.push( machine.DS, ocl.getConstructor( args));
        }
  catch (NoSuchMethodException nsm)
        {
         System.out.println( "Keinen entsprechenden Creator gefunden.");
        }
  catch (SecurityException     se)
        {
         System.out.println( "Creator unterliegt Security Management");
        }
 }
}
