
package engine;

import memory.*;

/**
Klasse zur Einleitung der Alternative bedingter Anweisungen.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _else extends Command {

 /**
 Creator
 */
 public _else() {
  immediate = true;
  name = "else";
 }

 /**
 Laufzeitverhalten des Commands.
 Ende des IF-bedingten Abschnitts ermitteln, Ziel in "_jumpf" (Jump_on_false) festlegen.
 Anfang des bedingten Abschnitts ermitteln, "_jump" (Jump) kompilieren.
 Das Ziel des Sprungbefehls wird von "endif" festgelegt.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
 _jump jmp   = new _jump();                     // unbedingte Sprunganweisung
 _jump ifjmp = (_jump)List.pop( machine.DS); // IF-Sprunganweisung (_jumpf) vom Datenstack holen

  List.append(   machine.HERE, jmp);        // ELSE-Sprunganweisung compilieren (Ziel fehlt)
  ifjmp.destination = machine.HERE.last;    // IF-Sprunganweisung festlegen
  ifjmp.index = List.length( machine.HERE); // Index setzen (nur Trace)
  List.push( machine.DS,  jmp);            // ELSE-Sprunganweisung auf Datenstack merken
 }
}
