
package engine;

import memory.*;

/**
Klasse zur Aufnahme eines Fields aus Objekten der JVM in den eigenen Sprachschatz.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _field extends Command {

 /**
 Creator
 */
 public _field() {
  name = "field";
 }

 /**
 Field als Command compilieren.
 Aus einer Klassen-/Instanz-Variable wird ein Command der V2M.
 Das Laufzeitverhalen entspricht weitgehend dem eine V2M-Variablen.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {          // inst name -->
 String name = (String)List.pop( machine.DS); // TOS = field-name
 Object inst = machine.DS.first.content;      // TOS = object-instance
 
  try   {
         if  (machine.DS.first.content instanceof Class)
              List.push( machine.DS,   ((Class)inst).getField( name)); // class  field
         else List.push( machine.DS, inst.getClass().getField( name)); // object field
        }
  catch (NoSuchFieldException nsf)
        {
         System.out.println( "Field ["+name+"] nicht gefunden");
         return;
        }
  catch (SecurityException    se)
        {
         System.out.println( "Field ["+name+"] unterliegt Security Management");
         return;
        }
 Command field = new _fld();      // Leeres Secondary erstellen
  field.name = machine.getWord(); // Secondary mit Namen versehen
  field.commands = new List();
  List.append(field.commands, List.pop( machine.DS)); // field
  List.append(field.commands, List.pop( machine.DS)); // instance
  List.push( machine.DICT, field);  // Secondary ins Dictionary intergrieren
 }
}
