
package engine;

import memory.*;

/**
Klasse zur Bestimmung des Commands aus der Bezeichnung (Namen).
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _find extends Command {

 /**
 Creator
 */
 public _find() {
  name = "find";
 }

 /**
 Laufzeitverhalten des Commands.
 Das Command, das unter der Bezeichnung des Strings auf dem Stack
 vorhanden ist, wird auf dem Stack abgelegt. Als Erfolgsmeldung
 wird zusätzlich noch ein true auf dem Stack untergebracht. Wenn
 kein Comand unter der Bezeichnung bekannt ist, wird nur false auf
 dem Stack abgelegt.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
 Command cmd = machine.getCommand( (String)List.pop( machine.DS));
 boolean flg = (cmd == null);

  if (!flg) List.push( machine.DS, cmd);
  List.push( machine.DS, new Boolean( !flg));
 }
}
