
package engine;

import memory.*;

/**
Klasse zur Bereitstellung einer Variablen.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _is extends Command {

 /**
 Creator
 */
 public _is() {
  name = "is";
 }

 /**
 Laufzeitverhalten des Commands.
 Stack = [ name object ]
 name: Name of the variable
 object: somethig to store.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
 String name = (String)List.pop( machine.DS);
 _var   var  = (_var)machine.getCommand( name);
 Object obj  = List.pop( machine.DS);

  var.commands = new List();
  if  (obj instanceof Command)                       // IF   command
       if   ((obj instanceof _meth) ||               //      IF   method or
             (obj instanceof _fld))                  //           field
             List.append( var.commands, obj);        //           a binary identity is used
        else var.commands = ((Command)obj).commands; //      ELSE a reference is made
  else List.append( var.commands, new _sym( obj));   // EÖSE an unary identity is used
 }
}
