
package engine;

import memory.*;

import java.lang.reflect.*;

/**
Klasse zur Belegung eines Fields mit einem Objekt. 
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _store extends Command {

 /**
 Creator
 */
 public _store() {
  name = "store";
 }

 /**
 Laufzeitverhalten des Commands.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
  store( machine);
 }

 /**
 Oberstes Stackobjekt in einem Field abspeichern.
 */
 public void store( V2M machine) {      // value field-name instance
 Object object = List.pop( machine.DS); // TOS = instance
 Field  field = null;
  try   {
         if  (object instanceof Class) 
              field = machine.field( (Class)object,     (String)List.pop( machine.DS));
         else field = machine.field( object.getClass(), (String)List.pop( machine.DS));
         field.set( object, List.pop( machine.DS));
        }
  catch (IllegalArgumentException iae)
        {
         System.out.println( "In \"_store\": Fehlerhafter Zugriff auf Inhalt");
         System.out.println( "Instance: ["+object.toString()+"]");
         System.out.println( "Field:    ["+field.toString()+"]");
        }
  catch (IllegalAccessException   iac)
        {
         System.out.println( "Fehlerhafter Zugriff auf Field");
        }
 }
}
