
import parsing.*;
import memory.*;

/**
Klasse zur Demonstration des einfachen Parsers.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class testParser {

 /**
 Einfacher Parser mit der Möglichkeit variable Längen von
 Argumentlisten bei "Funktionen" zu behandeln. Die Ausgabe
 der Ergebnisse erfolgt in post- und prefix Notation. Die
 Kommas bei prefix dienen hier zur bessren Lesbarkeit.
 @param args optionale Argumente (hier nicht verwendet).
 */
 static public void main( String args[]) {

// String term  = "-2 * -sin(a + b) + (-3 * (c - x)) / (d * e)";
 
// String term  = "2*sin(a+b)+(-3*(c-x))/(d*e)";
// String term  = "sin(a+b)+(-3*(c-x))/(d*e)";

// String term  = "xyz(x-2,sin(b-x),c,d)";
// String term  = "xyz(x<2,b>(x+y),c,d)";

 String term  = "-xyz(-x<>2,b>-(x+y),c,d)";
// String term  = "-xyz(-x<2,b>-(-x+y),c,d)";

// String term  = "sin(a + b) * -c";

 List atoms = null;

 Functions functions = new Functions();
 Operators operators = new Operators();

  functions.append( "xyz");
  functions.append( "neg");
  functions.append( "not");
  functions.append( "abs");
  functions.append( "cos");
  functions.append( "cot");
  functions.append( "exp");
  functions.append( "ln");
  functions.append( "sin");
  functions.append( "sqrt");
  functions.append( "tan");
  HandleTerm.functions = functions; // Liste der Funktionen

  operators.append( "(",  100);
  operators.append( ")",  100);
  operators.append( ",",  150);
  operators.append( "<",  200);
  operators.append( ">",  200);
  operators.append( "=",  200);
  operators.append( "!=", 200);
  operators.append( "<>", 200);
  operators.append( "<=", 200);
  operators.append( ">=", 200);
  operators.append( "|",  300);
  operators.append( "+",  300);
  operators.append( "-",  300);
  operators.append( "&",  400);
  operators.append( "*",  400);
  operators.append( "/",  400);
  operators.append( "!",  500);
  operators.append( "^",  500);
  HandleTerm.operators = operators; // Liste der Operationen


  System.out.println( "Post-DIREKT: ["+HandleTerm.postfix( term)+"]");
  System.out.println( "Prae-DIREKT: ["+HandleTerm.prefix(  term)+"]");

  System.out.println( "\nDie Eingabe:   " + term);

  atoms = HandleTerm.getAtoms( term);      // Term in Atome zerlegen
  System.out.print( "\nAtomare Liste: ");
 Item item = atoms.first;
  while (item != null)
        {
         System.out.print( "["+item.content.toString()+"]  ");
         item = item.next;
        }
  System.out.println();

  atoms = HandleTerm.buildPostfix( atoms); // Atome nach POSTfix wandeln
  System.out.print( "\nAls POSTFIX:   ");
  item = atoms.first;
  while (item != null)
        {
         System.out.print( item.content.toString() + " ");
         item = item.next;
        }
  System.out.println();

  atoms = HandleTerm.buildPrefix( atoms);  // POSTfix nach PREfix
  System.out.print( "\nAls PREFIX:    ");
  item = atoms.first;
  while (item != null)
        {
         System.out.print( item.content.toString());
         item = item.next;
        }
  System.out.println();

 }
}
